Index: i18n/uk.ts
===================================================================
--- i18n/uk.ts	(revision f0464480dbaed4452bd34ee92f4a2e0b8d6de557)
+++ i18n/uk.ts	(revision 0bd0e1aca7e5525e6b1b8316b276d6ee9b8f99d1)
@@ -6,20 +6,20 @@
     <name>CTSPModel</name>
     <message>
-        <location filename="../src/tspmodel.cpp" line="51"/>
+        <location filename="../src/tspmodel.cpp" line="121"/>
         <source>City %1</source>
         <translation>Місто %1</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="53"/>
+        <location filename="../src/tspmodel.cpp" line="123"/>
         <source>%1</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="147"/>
+        <location filename="../src/tspmodel.cpp" line="356"/>
         <source>Unexpected end of file.</source>
         <translation>Неочікуваний кінець файлу.</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="149"/>
+        <location filename="../src/tspmodel.cpp" line="358"/>
         <source>Corrupt data read. File possibly corrupted.</source>
         <translation>Прочитано ушкоджені дані.
@@ -27,31 +27,31 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="151"/>
+        <location filename="../src/tspmodel.cpp" line="360"/>
         <source>Unknown error.</source>
         <translation>Невідома помилка.</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="153"/>
-        <location filename="../src/tspmodel.cpp" line="163"/>
-        <location filename="../src/tspmodel.cpp" line="187"/>
-        <location filename="../src/tspmodel.cpp" line="208"/>
-        <location filename="../src/tspmodel.cpp" line="222"/>
-        <location filename="../src/tspmodel.cpp" line="257"/>
-        <location filename="../src/tspmodel.cpp" line="267"/>
+        <location filename="../src/tspmodel.cpp" line="141"/>
+        <location filename="../src/tspmodel.cpp" line="165"/>
+        <location filename="../src/tspmodel.cpp" line="362"/>
+        <location filename="../src/tspmodel.cpp" line="379"/>
+        <location filename="../src/tspmodel.cpp" line="393"/>
+        <location filename="../src/tspmodel.cpp" line="428"/>
+        <location filename="../src/tspmodel.cpp" line="438"/>
         <source>Task Load</source>
         <translation>Завантаження умови</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="153"/>
-        <location filename="../src/tspmodel.cpp" line="187"/>
-        <location filename="../src/tspmodel.cpp" line="208"/>
-        <location filename="../src/tspmodel.cpp" line="222"/>
-        <location filename="../src/tspmodel.cpp" line="257"/>
-        <location filename="../src/tspmodel.cpp" line="267"/>
+        <location filename="../src/tspmodel.cpp" line="165"/>
+        <location filename="../src/tspmodel.cpp" line="362"/>
+        <location filename="../src/tspmodel.cpp" line="379"/>
+        <location filename="../src/tspmodel.cpp" line="393"/>
+        <location filename="../src/tspmodel.cpp" line="428"/>
+        <location filename="../src/tspmodel.cpp" line="438"/>
         <source>Unable to load task:</source>
         <translation>Неможливо завантажити умову:</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="163"/>
+        <location filename="../src/tspmodel.cpp" line="141"/>
         <source>Unable to open task file.
 Error: %1</source>
@@ -60,11 +60,11 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="187"/>
+        <location filename="../src/tspmodel.cpp" line="165"/>
         <source>Unknown file format or file is corrupted.</source>
         <translation>Невідомий формат файлу або файл пошкоджено.</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="208"/>
-        <location filename="../src/tspmodel.cpp" line="257"/>
+        <location filename="../src/tspmodel.cpp" line="379"/>
+        <location filename="../src/tspmodel.cpp" line="428"/>
         <source>File version is newer than application supports.
 Please, try to update application.</source>
@@ -73,6 +73,6 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="222"/>
-        <location filename="../src/tspmodel.cpp" line="267"/>
+        <location filename="../src/tspmodel.cpp" line="393"/>
+        <location filename="../src/tspmodel.cpp" line="438"/>
         <source>Unexpected data read.
 File is possibly corrupted.</source>
@@ -81,17 +81,17 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="303"/>
-        <location filename="../src/tspmodel.cpp" line="311"/>
-        <location filename="../src/tspmodel.cpp" line="319"/>
-        <location filename="../src/tspmodel.cpp" line="327"/>
-        <location filename="../src/tspmodel.cpp" line="335"/>
-        <location filename="../src/tspmodel.cpp" line="343"/>
-        <location filename="../src/tspmodel.cpp" line="351"/>
-        <location filename="../src/tspmodel.cpp" line="362"/>
+        <location filename="../src/tspmodel.cpp" line="228"/>
+        <location filename="../src/tspmodel.cpp" line="236"/>
+        <location filename="../src/tspmodel.cpp" line="244"/>
+        <location filename="../src/tspmodel.cpp" line="252"/>
+        <location filename="../src/tspmodel.cpp" line="260"/>
+        <location filename="../src/tspmodel.cpp" line="268"/>
+        <location filename="../src/tspmodel.cpp" line="276"/>
+        <location filename="../src/tspmodel.cpp" line="287"/>
         <source>Task Save</source>
         <translation>Збереження умови</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="303"/>
+        <location filename="../src/tspmodel.cpp" line="228"/>
         <source>Unable to create task file.
 Error: %1
@@ -102,11 +102,11 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="311"/>
-        <location filename="../src/tspmodel.cpp" line="319"/>
-        <location filename="../src/tspmodel.cpp" line="327"/>
-        <location filename="../src/tspmodel.cpp" line="335"/>
-        <location filename="../src/tspmodel.cpp" line="343"/>
-        <location filename="../src/tspmodel.cpp" line="351"/>
-        <location filename="../src/tspmodel.cpp" line="362"/>
+        <location filename="../src/tspmodel.cpp" line="236"/>
+        <location filename="../src/tspmodel.cpp" line="244"/>
+        <location filename="../src/tspmodel.cpp" line="252"/>
+        <location filename="../src/tspmodel.cpp" line="260"/>
+        <location filename="../src/tspmodel.cpp" line="268"/>
+        <location filename="../src/tspmodel.cpp" line="276"/>
+        <location filename="../src/tspmodel.cpp" line="287"/>
         <source>Unable to save task.
 Error: %1</source>
@@ -118,25 +118,25 @@
     <name>CTSPSolver</name>
     <message>
-        <location filename="../src/tspsolver.cpp" line="138"/>
+        <location filename="../src/tspsolver.cpp" line="91"/>
         <source>%v of %m parts found</source>
         <translation>Знайдено %v з %m переходів</translation>
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="142"/>
+        <location filename="../src/tspsolver.cpp" line="95"/>
         <source>Calculating optimal route...</source>
         <translation>Обчислення оптимального шляху...</translation>
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="143"/>
+        <location filename="../src/tspsolver.cpp" line="96"/>
         <source>Solution Progress</source>
         <translation>Поступ розв&apos;зку</translation>
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="217"/>
+        <location filename="../src/tspsolver.cpp" line="170"/>
         <source>Solution Result</source>
         <translation>Результат розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="217"/>
+        <location filename="../src/tspsolver.cpp" line="170"/>
         <source>Unable to find solution.
 Maybe, this task has no solutions.</source>
@@ -145,7 +145,7 @@
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="235"/>
-        <location filename="../src/tspsolver.cpp" line="237"/>
-        <location filename="../src/tspsolver.cpp" line="240"/>
+        <location filename="../src/tspsolver.cpp" line="42"/>
+        <location filename="../src/tspsolver.cpp" line="44"/>
+        <location filename="../src/tspsolver.cpp" line="47"/>
         <source>City %1</source>
         <translation>Місто %1</translation>
@@ -155,186 +155,186 @@
     <name>MainWindow</name>
     <message>
-        <location filename="../ui/mainwindow.ui" line="78"/>
+        <location filename="../ui/mainwindow.ui" line="79"/>
         <source>Number of variant</source>
         <translation>Номер варіанту</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="101"/>
+        <location filename="../ui/mainwindow.ui" line="102"/>
         <source>Number of cities</source>
         <translation>Кількість міст, що проходить комівояжер</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="288"/>
+        <location filename="../ui/mainwindow.ui" line="289"/>
         <source>Save &amp;As</source>
         <translation>Зберегти &amp;як</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="310"/>
+        <location filename="../ui/mainwindow.ui" line="311"/>
         <source>Select language</source>
         <translation>Вибір мови</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="313"/>
+        <location filename="../ui/mainwindow.ui" line="314"/>
         <source>Select application language</source>
         <translation>Обрати мову додатку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="349"/>
+        <location filename="../ui/mainwindow.ui" line="350"/>
         <source>Toolbar</source>
         <translation>Панель інструментів</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="374"/>
+        <location filename="../ui/mainwindow.ui" line="375"/>
         <source>P&amp;rint Preview...</source>
         <translation>&amp;Попередній перегляд...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="377"/>
+        <location filename="../ui/mainwindow.ui" line="378"/>
         <source>Print Preview...</source>
         <translation>Попередній перегляд...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="380"/>
+        <location filename="../ui/mainwindow.ui" line="381"/>
         <source>Preview solution results</source>
         <translation>Попередній перегляд результатів розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="383"/>
+        <location filename="../ui/mainwindow.ui" line="384"/>
         <source>Preview current solution results before printing</source>
         <translation>Попередній перегляд результатів розв&apos;язку перед друком</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="395"/>
+        <location filename="../ui/mainwindow.ui" line="396"/>
         <source>&amp;Print...</source>
         <translation>&amp;Друк...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="398"/>
+        <location filename="../ui/mainwindow.ui" line="399"/>
         <source>Print...</source>
         <translation>Друк...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="401"/>
+        <location filename="../ui/mainwindow.ui" line="402"/>
         <source>Print solution</source>
         <translation>Друк розв&apos;зку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="404"/>
+        <location filename="../ui/mainwindow.ui" line="405"/>
         <source>Print current solution results</source>
         <translation>Роздрукувати поточний результат розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="407"/>
+        <location filename="../ui/mainwindow.ui" line="408"/>
         <source>Ctrl+P</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="415"/>
+        <location filename="../ui/mainwindow.ui" line="416"/>
         <source>&amp;Solution...</source>
         <translation>&amp;Розв&apos;язок...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="601"/>
+        <location filename="../ui/mainwindow.ui" line="602"/>
         <source>Save</source>
         <translation>Зберегти</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="572"/>
+        <location filename="../ui/mainwindow.ui" line="573"/>
         <source>Detect language automatically</source>
         <translation>Визначати мову автоматично</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="575"/>
+        <location filename="../ui/mainwindow.ui" line="576"/>
         <source>Detect language automatically based on regional settings</source>
         <translation>Визначати мову автоматично, використовуючи регіональні стандарти</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="610"/>
+        <location filename="../ui/mainwindow.ui" line="611"/>
         <source>Ctrl+S</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="445"/>
+        <location filename="../ui/mainwindow.ui" line="446"/>
         <source>Ctrl+N</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="44"/>
+        <location filename="../ui/mainwindow.ui" line="45"/>
         <source>Task</source>
         <translation>Умова</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="65"/>
+        <location filename="../ui/mainwindow.ui" line="66"/>
         <source>&amp;Variant:</source>
         <translation>&amp;Варіант:</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="88"/>
+        <location filename="../ui/mainwindow.ui" line="89"/>
         <source>&amp;Cities:</source>
         <translation>&amp;Міст:</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="129"/>
+        <location filename="../ui/mainwindow.ui" line="130"/>
         <source>Cost of travel from city to city</source>
         <translation>Вартість переїзду з міста у місто</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="157"/>
+        <location filename="../ui/mainwindow.ui" line="158"/>
         <source>Fill table with random numbers</source>
         <translation>Заповнити таблицю випадковими значеннями</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="160"/>
+        <location filename="../ui/mainwindow.ui" line="161"/>
         <source>Random</source>
         <translation>Випадково</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="174"/>
+        <location filename="../ui/mainwindow.ui" line="175"/>
         <source>Solve current task</source>
         <translation>Розв&apos;язати поточну задачу</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="177"/>
+        <location filename="../ui/mainwindow.ui" line="178"/>
         <source>Solve</source>
         <translation>Розв&apos;язати</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="191"/>
+        <location filename="../ui/mainwindow.ui" line="192"/>
         <source>Solution</source>
         <translation>Розв&apos;язок</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="200"/>
+        <location filename="../ui/mainwindow.ui" line="201"/>
         <source>Solution steps</source>
         <translation>Хід розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="221"/>
-        <location filename="../ui/mainwindow.ui" line="424"/>
+        <location filename="../ui/mainwindow.ui" line="222"/>
+        <location filename="../ui/mainwindow.ui" line="425"/>
         <source>Save solution to a file</source>
         <translation>Зберегти розв&apos;язок у файл</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="224"/>
+        <location filename="../ui/mainwindow.ui" line="225"/>
         <source>Save Solution</source>
         <translation>Зберегти</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="251"/>
+        <location filename="../ui/mainwindow.ui" line="252"/>
         <source>Go back to Task tab</source>
         <translation>Повернутися до закладки &quot;Умова&quot;</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="254"/>
+        <location filename="../ui/mainwindow.ui" line="255"/>
         <source>Back to Task</source>
         <translation>До умови</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="284"/>
+        <location filename="../ui/mainwindow.ui" line="285"/>
         <source>&amp;File</source>
         <translation>&amp;Файл</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="316"/>
+        <location filename="../ui/mainwindow.ui" line="317"/>
         <source>&amp;Language</source>
         <comment>Please, append &quot; / Language&quot; when translating this string.</comment>
